unit uCountThread;

interface

uses
  Classes;

type
  // 󲿷ֹ࣬¼˵οһʾ 004 ˵

  TOnMsg = procedure(AMsg: string) of object;

  TCountThread = class;
  TCountAction = (caNothing, caAsc, caDesc, caStop);

  // caNothing ɶҲ
  // caAsc ˳
  // caDesc 
  // caStop ֹͣ

  TOnCountNum = procedure(Sender: TCountThread; ANum: integer) of object;

  TCountThread = class(TThread)
  private
    FOnMsg: TOnMsg;
    FNum: integer;
    FOnCountNum: TOnCountNum;

    procedure DoOnMsg(AMsg: string);
    procedure DoOnCountNum(ANum: integer);
    procedure SetOnMsg(val: TOnMsg);
    procedure SetOnCountNum(val: TOnCountNum);

  protected
    procedure Execute; override; // ̳и
  public
    constructor Create; reintroduce;
    procedure Lock;
    procedure Unlock;
  public
    CountAction: TCountAction;
    property OnMsg: TOnMsg read FOnMsg write SetOnMsg;
    property OnCountNum: TOnCountNum read FOnCountNum write SetOnCountNum;
  end;

implementation

{ TCountThread }

constructor TCountThread.Create;
begin
  inherited Create(false); //ִ execute еĴ
  FreeOnTerminate := false; //˳ execute 󣬲ͷ߳Դɵֶͷ
  CountAction := caNothing;
  FNum := 100;
end;

procedure TCountThread.DoOnCountNum(ANum: integer);
begin
  if Assigned(FOnCountNum) then
    FOnCountNum(self, ANum);
end;

procedure TCountThread.DoOnMsg(AMsg: string);
begin
  if Assigned(FOnMsg) then
    FOnMsg(AMsg);
end;

procedure TCountThread.Execute;
begin
  inherited;

  // Ҫ̲߳˳Ҫȷһֱڱ
  // һѭǱȻ

  while not Terminated do
  begin

    // Terminated  TThread һ
    // Terminate; ̵þ: Terminated:=true;
    //  FrmCount лõ

    Lock;
    // ΪʲôҪ lock?
    // Ϊ˴˴ CountAction 
    // ߳ҲҪ CountAction  Lock,ȷָȷ

    // Ȼûʲô壬Ҫ lock Ҳԡ
    // ʵʹУҪע

    try
      if CountAction = caAsc then
      begin
        inc(FNum);
        DoOnCountNum(FNum); // ¼
      end
      else if CountAction = caDesc then
      begin
        dec(FNum);
        DoOnCountNum(FNum);
      end
      else if CountAction = caStop then
      begin
        DoOnMsg('ֹͣ!');
        CountAction := caNothing;
      end;
    finally
      Unlock;
    end;

    sleep(100);

    // ˴ sleep ѭΪ˽ѧ
    // һìܵ飬Ҫ߳Ӧٶȿ죬sleep ʱӦö̡
    // Ҫ߳̽ԼԴϣ sleep һ

    // ʵḶ́߳һ㲻д TEvent ѭ⡣
    // οд TSimpleThread
    // http://www.cnblogs.com/lackey/p/5371544.html

  end;

  DoOnMsg('̴߳˳ Execute ');

  //һеˣ̵߳Ӵ˽

end;

procedure TCountThread.Lock;
begin
  System.TMonitor.Enter(self);
end;

procedure TCountThread.Unlock;
begin
  System.TMonitor.Exit(self);
end;

procedure TCountThread.SetOnMsg(val: TOnMsg);
begin
  FOnMsg := val;
end;

procedure TCountThread.SetOnCountNum(val: TOnCountNum);
begin
  FOnCountNum := val;
end;

end.
